#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <hamsandwich>

//#define I_WILL_SET_MAXHEALTH_MYSELF 

#define PLUGIN "BOX Leczenie"
#define VERSION "1.0"
#define AUTHOR "R3X"

#define HEAL_PER_SECOND get_pcvar_float(gcvarHealPerSecond)

new bool:gbHeal[33];
new gcvarHealPerSecond;

new Float:gfLastThink[33];

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	RegisterHam( Ham_Spawn, 	"player", 	"fwPlayerSpawn", 	1 );
	register_forward( FM_PlayerPreThink, 		"fwPlayerPreThink", 	1 );
	gcvarHealPerSecond = register_cvar("box_heal_per_second", "13.0");
}

public box_start_touch(box, ent, const szClass[])
{	
	if(!is_user_alive(ent)) 
		return PLUGIN_CONTINUE;
		
	if(equal(szClass, "Leczenie"))
	{
		Create_StatusIcon(ent, 1, "cross", 200, 20, 20);
		gbHeal[ent] = true;
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

public box_stop_touch(box, ent, const szClass[])
{
	if(!is_user_alive(ent)) 
		return PLUGIN_CONTINUE;
		
	if(equal(szClass, "Leczenie"))
	{
		Create_StatusIcon(ent, 0, "cross");
		gbHeal[ent] = false;
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

public fwPlayerSpawn(id)
{
#if !defined I_WILL_SET_MAXHEALTH_MYSELF
	if(!is_user_alive(id))
		return HAM_IGNORED;
	
	set_pev(id, pev_max_health, 100.0);
#endif	
	
	return HAM_IGNORED;
}
public fwPlayerPreThink(id){
	if(is_user_alive(id) )
	{		
		new Float:fNow = get_gametime();
		
		if(gbHeal[id]){
			new Float:fInterval = fNow-gfLastThink[id];
			
			new Float:fHP, Float:fMax;
			pev(id, pev_health, fHP);
			pev(id, pev_max_health, fMax);
			
			if(fHP < fMax )
			{
				fHP = floatmin(fMax, fHP + fInterval*HEAL_PER_SECOND);
				set_pev(id, pev_health, fHP);
			}
			else if(fHP > fMax )
			{
				fHP = floatmax(fMax, fHP - fInterval*HEAL_PER_SECOND);
				set_pev(id, pev_health, fHP);
			}
		}
		gfLastThink[id] = fNow;	
	}
}

stock Create_StatusIcon(id, status, const szSprite[], r=0, g=0, b=0)
{
	static iconstatus = 0;
	if(!iconstatus)
		iconstatus = get_user_msgid("StatusIcon");
		
	message_begin(MSG_ONE,iconstatus,{0,0,0},id);
	write_byte(status); // status (0=hide, 1=show, 2=flash)
	write_string(szSprite); 
	write_byte(r);
	write_byte(g);
	write_byte(b);
	message_end();
}
